<template>
  <q-inner-loading
    color="grey"
    size="80px"
    showing
  />
</template>

<script>
export default {
  name: 'PageToken',
  mounted () {
    this.fetchUser(this.$route.query)
  },
  methods: {
    async fetchUser ({ userId, accessToken }) {
      if (!userId || !accessToken) {
        this.$router.push('/auth/login')

        return undefined
      }

      window.sessionStorage.setItem('autoLogin', JSON.stringify({ userId, accessToken }))
      this.$axios.defaults.headers.common.Authorization = accessToken

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Usuarios/${userId}`,
          params: { filter: { fields: ['id', 'name', 'email', 'avatar', 'lstACL'] } }
        }

        const session = await this.$axios(axiosConfig).then(R => R.data)

        if (!session.lstACL[0]) {
          this.$router.push('/auth/logout')

          return undefined
        }

        this.$acl.change(session.lstACL[0] || 'authenticated')
        this.$store.commit('session/set', { user: session })
        this.$router.push(window.sessionStorage.urlGoTo || '/')
      } catch (err) {
        this.axiosCatch(err, '/auth/logout')
      }
    }
  }
}
</script>
